/*
 * tmos - clear_page.c
 *
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <tmos/kernel.h>
#include <asm/system.h>

void clear_page(page_t page) __reentrant
{
	unsigned long __xdata *p = page_to_virt(page);
	unsigned char i = PAGE_SIZE / sizeof(unsigned long);

	do {
		*p++ = 0;
		i--;
	} while (i > 0);
}
