/*
 * tmos - copy_page.c
 *
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <tmos/kernel.h>

void copy_page(page_t src, page_t dst) __reentrant
{
	unsigned int __xdata *d = page_to_virt(dst);
	const unsigned int __xdata *s = page_to_virt(src);

	do {
		*d++ = *s++;
	} while (((unsigned char) s) & (PAGE_SIZE - 1));
}
