/*
 * tmos - io.h
 *
 * I/O space access
 *
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_IO_H
#define __ASM_IO_H

#include <tmos/types.h>
#include <asm/irqs.h>

typedef u8 ioaddr_t;

void iowrite8(u8 val, ioaddr_t addr) __reentrant;
u8 ioread8(ioaddr_t addr) __reentrant;
u16 ioread16(ioaddr_t addr) __reentrant;
u16 ioread16_timer(ioaddr_t addr) __using(TIMER_BANK) __reentrant;

char ioread8_copy(ioaddr_t addr, u8 __kernel* dst, unsigned char count)
	__reentrant;

#endif
