/*
 * tmos - memset-kernel.c
 * 
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/string.h>

#ifndef memset_kernel
void memset_kernel(void __kernel *_dst, unsigned char _c, unsigned char _n)
	__reentrant
{
	unsigned char __kernel *dst = _dst;
	unsigned char c = _c;
	unsigned char n = _n;

	if (n > 0) {
		do {
			*dst++ = c;
		} while (--n > 0);
	}
}
#endif
